// update_year_range
(function(){
	function update_year_range(gantt){
		gantt.form_blocks.getTimePicker = function(sns, hidden) {
			var time_format = sns.time_format;
			if (!time_format) {
				// default order
				var time_format = ["%d", "%m", "%Y"];
				if(gantt._get_line(gantt._tasks.unit) < gantt._get_line("day")){
					time_format.push("%H:%i");
				}
			}
			// map: default order => real one
			sns._time_format_order = { size:0 };


			var cfg = this.config;
			var dt = this.date.date_part(new Date(gantt._min_date.valueOf()));
			var last = 24*60, first = 0;
			if(gantt.config.limit_time_select){
				last = 60*cfg.last_hour+1;
				first = 60*cfg.first_hour;
				dt.setHours(cfg.first_hour);
			}
			var html = "";

			for (var p = 0; p < time_format.length; p++) {
				var time_option = time_format[p];

				// adding spaces between selects
				if (p > 0) {
					html += " ";
				}

				var options = '';
				switch (time_option) {
					case "%Y":
						sns._time_format_order[2] = p;
						sns._time_format_order.size++;
						//year

						var range, offset, start_year, end_year;

						if(sns.year_range){
							if(!isNaN(sns.year_range)){
								range = sns.year_range;
							}else if(sns.year_range.push){
								// if
								start_year = sns.year_range[0];
								end_year = sns.year_range[1];
							}
						}

						range = range || 10;
						offset = offset || Math.floor(range/2);
						start_year = start_year || dt.getFullYear() - offset;
						end_year = end_year || start_year + range;


						for (var i=start_year; i < end_year; i++)
							options+="<option value='"+(i)+"'>"+(i)+"</option>";
						break;
					case "%m":
						sns._time_format_order[1] = p;
						sns._time_format_order.size++;
						//month
						for (var i=0; i < 12; i++)
							options+="<option value='"+i+"'>"+this.locale.date.month_full[i]+"</option>";
						break;
					case "%d":
						sns._time_format_order[0] = p;
						sns._time_format_order.size++;
						//days
						for (var i=1; i < 32; i++)
							options+="<option value='"+i+"'>"+i+"</option>";
						break;
					case "%H:%i":
						//  var last = 24*60, first = 0;
						sns._time_format_order[3] = p;
						sns._time_format_order.size++;
						//hours
						var i = first;
						var tdate = dt.getDate();
						sns._time_values = [];

						while(i<last){
							var time=this.templates.time_picker(dt);
							options+="<option value='"+i+"'>"+time+"</option>";
							sns._time_values.push(i);
							dt.setTime(dt.valueOf()+this._get_timepicker_step()*60*1000);
							var diff = (dt.getDate()!=tdate)?1:0; // moved or not to the next day
							i=diff*24*60+dt.getHours()*60+dt.getMinutes();
						}
						break;
					default:
						break;
				}

				if(options){
					var readonly = sns.readonly ? "disabled='disabled'" : "";
					var display = hidden ? " style='display:none'" : "";
					html += "<select "+readonly+display +">"+options+"</select>";
				}
			}
			return html;
		}
	};

	update_year_range(gantt);
	if(window.Gantt && Gantt.plugin){
		Gantt.plugin(update_year_range);

	}
})();